'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _immutable = require('immutable');

var Immutable = _interopRequireWildcard(_immutable);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash.memoize');

var _lodash2 = _interopRequireDefault(_lodash);

var _reselect = require('reselect');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function shallowEqual(a, b) {
  if (a === b) return true;
  if (a && b) {
    if (a.size !== b.size) return false;
    return a.every(function (value, key) {
      return value === b.get(key);
    });
  }
  return false;
}

var createShallowEqualSelector = (0, _reselect.createSelectorCreator)(_reselect.defaultMemoize, shallowEqual);

var selectPluginRoutes = (0, _lodash2.default)(function (routeKeyOrFunc) {
  var getRoutes = routeKeyOrFunc instanceof Function ? routeKeyOrFunc : function (plugin) {
    return plugin.getIn(['routes', routeKeyOrFunc]);
  };

  var stage0 = (0, _reselect.createSelector)(function (state) {
    return state.get('plugins');
  }, function (plugins) {
    return plugins.map(getRoutes);
  });

  return createShallowEqualSelector(function (state) {
    return stage0(state);
  }, function (routeMap) {
    var result = [];
    routeMap.forEach(function (routes) {
      if (routes) {
        if (Array.isArray(routes)) result.push.apply(result, _toConsumableArray(routes));else result.push(routes);
      }
    });
    return result.map(function (route, index) {
      return _react2.default.isValidElement(route) ? _react2.default.cloneElement(route, { key: index }) : route;
    });
  });
});

exports.default = selectPluginRoutes;